#include<stdio.h>
#include<stdlib.h>
#include "llist.h"

void print_node_at(NODE *head, int pos){
//prints by index
	NODE *currentNode;

	currentNode = head;

	for (int i = 0; i<pos; i++){
		currentNode = currentNode->next;
	}
	printf("The data at index %d is: %d\n", pos, currentNode->data);
}

void print_node(NODE *head){
//prints head
	printf("%d\n", head->data);}

void print_list(NODE *head){
	NODE *currentNode;
	currentNode = head;

	int i = 0;

	while (currentNode != NULL){
		printf("Index: %d; Data: %d\n",i,currentNode->data);
		currentNode=currentNode->next;
		i++;
	}
}

NODE_INT psearch(NODE *head, datatype data){
//return:
// positive : index where data was found; NODE* return is pointer to where
// -1 : not found; NODE* return is NULL
	printf("Searching list for: %d\n", data);
	NODE_INT node = search(head, data);
	if(node.node != NULL)
		printf("Location found, index: %d.\n", node.num);
	else
		puts("Not found in this list.");
	return node;
}

NODE_INT search(NODE *head, datatype data){
//return:
// positive : index where data was found; NODE* return is pointer to where
// -1 : not found; NODE* return is NULL
	NODE_INT curr;
	curr.node = head;
	int i;
	for(i=0;curr.node != NULL;i++){
		if(curr.node->data == data){
			curr.num=i;
			return curr;
		}
		curr.node=curr.node->next;
	}
	curr.node = NULL;
	curr.num = -1;
	return curr;
}

NODE *construct(datatype data, NODE *next){
//return:
// pointer to new node : normal
// NULL : malloc failed
	NODE *out = malloc(sizeof(NODE));
	if(out != NULL){
		out->data = data;
		out->next = next;
	}
	return out;
}

NODE_INT traverse(NODE *head, int pos){
//return:
// 0 : normal
// 1 : head is null; NODE* return is NULL
// 2 : reached end of list; NODE* return is final element
	NODE_INT out;
	out.node = head;
	out.num = 1;
	if(head==NULL)
		return out;
	int i;
	out.num = 0;
	for(i=0;i<pos || pos<0;i++){
		if(out.node->next != NULL)
			out.node = out.node->next;
		else{
			out.num = 2;
			break;
		}
	}
	return out;
}

int delete_node_after(NODE *head){
//return:
// 0 : normal
// 1 : head is NULL, or head->next is NULL, which means no node after to delete
	if(head==NULL || head->next == NULL)
		return 1;
	NODE* tmp = head->next;
	head->next = head->next->next;
	free(tmp);
	return 0;
}

void delete_list(NODE *head){
	if(head == NULL)
		return;
	NODE *tmp = head->next;
	free(head);
	delete_list(tmp);
}

NODE *construct_list(datatype list[], int size){
//return:
// pointer to head : normal
// NULL : malloc failed
	if(size<=0)
		return NULL;
	NODE *next = construct(list[size-1],NULL);
	NODE *head;
	int i;
	for(i=size-2;i>=0;i--){
		head = next;
		next = construct(list[i],head);
		if(next == NULL)
			delete_list(head);
	}
	return next;
}

int add_to_end(NODE *head, datatype new_data){
	return insert_node(head, -1, new_data);
}

int insert_node(NODE *head, int pos, datatype new_data){
//return:
// 0 : normal
// 1 : head is NULL
// 2 : malloc failed
// 3 : pos is larger than length(head)
	if(head==NULL)
		return 1;
	if(pos!=0){
		NODE_INT traverseResult = traverse(head,pos-1);
		int insertResult;
		if(traverseResult.num == 2 && pos > 0)
			return 3;
		return insert_node_after(traverseResult.node,new_data);
	}
	else{
		int out = insert_node_after(head,head->data);
		if(out>0)
			return out;
		head->data = new_data;
	}
	return 0;
}

int insert_node_after(NODE *head, datatype data){
//return:
// 0 : normal
// 1 : head is NULL
// 2 : malloc failed
	if(head==NULL)
		return 1;
	NODE *new = construct(data, head->next);
	if(new == NULL)
		return 2;
	head->next = new;
	return 0;
}


int length(NODE *head){
//returns length of list
	if(head==NULL)
		return 0;
	int i=1;
	while((head=head->next) != NULL)
		i++;
	return i;
}
